# FF-Meta, a set of meta-packages used by FFOS to customize installs
# Copyright (C) 2020  Evan La Fontaine (FRC Team 4739, CTRL F5)

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


image: archlinux/base

stages:
    - build
    - deploy

build-package:
    stage: build
    before_script:
    - pacman --noconfirm -Sy base-devel
    script:
    - pacman -Sw xf86-video-nouveau xf86-video-amdgpu xf86-video-intel --cachedir packages/graphics --noconfirm
    - cd packages/graphics
    - mv *nouveau* nouveau.pkg.tar.zst
    - mv *amdgpu* amdgpu.pkg.tar.zst
    - mv *intel* intel.pkg.tar.zst
    - cd ../..
    - sed -i "s@__BUILD__@$CI_PIPELINE_IID@" variables.conf
    - sed -i "s@__SRV__@$PRODUCTION_IP@" variables.conf
    - sed -i "s@__SRV_TEST__@$TESTING_IP@" variables.conf
    - chmod 777 build.sh
    - ./build.sh
    artifacts:
        paths:
        - ./*.pkg.tar.lz4

deploy-testing-package:
    stage: deploy
    before_script:
    - pacman --noconfirm -Sy sshfs
    - chmod 400 $TESTING_SSH
    script:
    - sshfs root@$TESTING_IP:/export/zfs/chsc/html/packages /mnt -p $TESTING_PORT -o IdentityFile=$TESTING_SSH -o StrictHostKeyChecking=no
    - cp ./*.pkg.tar.lz4 /mnt
    - cd /mnt
    - rm ffps-testing.db ffps-testing.db.tar.gz ffps-testing.files ffps-testing.files.tar.gz
    - repo-add ffps-testing.db.tar.gz *.pkg.tar.*
    dependencies:
    - build-package
deploy-production-package:
    stage: deploy
    only:
        refs:
        - production
    before_script:
    - pacman --noconfirm -Sy sshfs
    - chmod 400 $PRODUCTION_SSH
    script:
    - sshfs root@$PRODUCTION_IP:/export/zfs/chsc/html/packages /mnt -p $PRODUCTION_PORT -o IdentityFile=$PRODUCTION_SSH -o StrictHostKeyChecking=no
    - cp ./*.pkg.tar.lz4 /mnt
    - cd /mnt
    - rm ffps.db ffps.db.tar.gz ffps.files ffps.files.tar.gz
    - repo-add ffps.db.tar.gz *.pkg.tar.*
    dependencies:
    - build-package
